
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
	.global	apu_square_duty_table
	.code
	.align	2
apu_square_duty_table:
	.byte	2
	.byte	4
	.byte	8
	.byte	12
	.global	apu_triangle_waveform_table
	.align	2
apu_triangle_waveform_table:
	.byte	8
	.byte	24
	.byte	40
	.byte	56
	.byte	72
	.byte	88
	.byte	104
	.byte	120
	.byte	120
	.byte	104
	.byte	88
	.byte	72
	.byte	56
	.byte	40
	.byte	24
	.byte	8
	.byte	-8
	.byte	-24
	.byte	-40
	.byte	-56
	.byte	-72
	.byte	-88
	.byte	-104
	.byte	-120
	.byte	-120
	.byte	-104
	.byte	-88
	.byte	-72
	.byte	-56
	.byte	-40
	.byte	-24
	.byte	-8
	.global	apu_noise_wavelength_table
	.align	2
apu_noise_wavelength_table:
	.half	4
	.half	8
	.half	16
	.half	32
	.half	64
	.half	96
	.half	128
	.half	160
	.half	202
	.half	254
	.half	380
	.half	508
	.half	762
	.half	1016
	.half	2034
	.half	4068
	.global	apu_length_count_table
	.align	2
apu_length_count_table:
	.byte	5
	.byte	127
	.byte	10
	.byte	1
	.byte	20
	.byte	2
	.byte	40
	.byte	3
	.byte	80
	.byte	4
	.byte	30
	.byte	5
	.byte	7
	.byte	6
	.byte	14
	.byte	7
	.byte	6
	.byte	8
	.byte	12
	.byte	9
	.byte	24
	.byte	10
	.byte	48
	.byte	11
	.byte	96
	.byte	12
	.byte	36
	.byte	13
	.byte	8
	.byte	14
	.byte	16
	.byte	15
	.code
	.align	1
	.global	apu_reset
apu_reset:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	apu+0x0@h	; 	xld.w	%r12,apu
	ext	apu+0x0@m
	ld.w	%r12,apu+0x0@l
	ld.w	%r13,0x0
	ext	0x1		; 	xld.w	%r14,0x0000006c		; 108
	ld.w	%r14,0x2c
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	ret
	.align	1
	.global	apu_write
apu_write:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	apu+0x0@h	; 	xld.w	%r5,apu
	ext	apu+0x0@m
	ld.w	%r5,apu+0x0@l
	ld.w	%r6,%r5
	ext	0x48		; 	xadd	%r15,%r5,72
	add	%r15,%r5
	ext	0x54		; 	xadd	%r14,%r5,84
	add	%r14,%r5
	and	%r12,0x1f	; 	xand	%r12,%r12,0x0000001f
	ld.w	%r4,%r12
	and	%r4,0x3c	; 	xand	%r4,%r4,0xfffffffc
	ld.w	%r10,%r12
	add	%r10,%r5
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
	cmp	%r12,0xf	; 	xcmp	%r12,15
	ext	__L28@rm	; 	xjrugt	__L28
	jrugt	__L28@rl
	ld.w	%r10,%r12
	sll	%r10,0x2	; 	xsll	%r10,2
	ext	__L58+0x0@h	; 	xld.w	%r10,[%r10+__L58]
	ext	__L58+0x0@m
	ld.w	%r9,__L58+0x0@l
	add	%r9,%r10
	ld.w	%r10,[%r9]
	jp	%r10
	.code
	.align	2
__L58:
	.word	__L30
	.word	__L35
	.word	__L43
	.word	__L39
	.word	__L30
	.word	__L35
	.word	__L43
	.word	__L39
	.word	__L28
	.word	__L28
	.word	__L49
	.word	__L44
	.word	__L50
	.word	__L28
	.word	__L57
	.word	__L54
	.code
__L30:
	ld.w	%r11,%r12
	sra	%r11,0x2	; 	xsra	%r11,2
	ld.w	%r10,0x14	; 	xld.w	%r10,0x00000014		; 20
	mlt.w	%r11,%r10
	ext	0x0		; 	xld.w	%r15,0x00000020		; 32
	ld.w	%r15,0x20
	ld.w	%r10,%alr
	add	%r10,%r15
	ld.w	%r14,%r6
	add	%r14,%r10
	ext	0x2		; 	xadd	%r12,%r14,2
	add	%r12,%r14
	ld.w	%r7,0x0
	ld.b	[%r12],%r7	; 	xld.b	[%r12],%r7
	ld.w	%r11,%r5
	add	%r11,%r4
	ld.ub	%r13,[%r11]	; 	xld.ub	%r13,[%r11]
	ld.w	%r10,%r13
	and	%r10,0x10	; 	xand	%r10,%r10,0x00000010
	ext	__LX51@rm	; 	xjrne	__L51
	jrne	__LX51@rl
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	and	%r10,%r15
	ld.ub	%r10,%r10
	ext	__LX64@rm	; 	xjp	__L64
	jp	__LX64@rl
__L35:
	ld.w	%r11,%r12
	sra	%r11,0x2	; 	xsra	%r11,2
	ld.w	%r10,0x14	; 	xld.w	%r10,0x00000014		; 20
	mlt.w	%r11,%r10
	ld.w	%r10,%alr
	add	%r10,0x20	; 	xadd	%r10,%r10,32
	ld.w	%r14,%r6
	add	%r14,%r10
	ext	0x6		; 	xadd	%r12,%r14,6
	add	%r12,%r14
	ld.w	%r7,0x0
	ld.b	[%r12],%r7	; 	xld.b	[%r12],%r7
	ld.w	%r10,%r4
	add	%r10,%r5
	ext	0x1		; 	xadd	%r11,%r10,1
	add	%r11,%r10
	btst	[%r11],0x7	; 	xbtst	[%r11],0x7
	ext	__L28@rm	; 	xjreq	__L28
	jreq	__L28@rl
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	btst	[%r11],0x3	; 	xbtst	[%r11],0x3
	jreq	__LX37		; 	xjreq	__L37
	ld.w	%r10,0x3	; 	xld.w	%r10,0x00000003		; 3
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
__LX37:				; __L37:
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	ext	0x7		; 	xld.b	[%r14+7],%r10
	ld.b	[%r14],%r10
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	add	%r10,0x1	; 	xadd	%r10,%r10,1
	ext	0x8		; 	xld.b	[%r14+8],%r10
	ld.b	[%r14],%r10
	ext	0x9		; 	xld.b	[%r14+9],%r10
	ld.b	[%r14],%r10
	ext	__L28@rm	; 	xjp	__L28
	jp	__L28@rl
__L39:
	ld.w	%r11,%r12
	sra	%r11,0x2	; 	xsra	%r11,2
	ld.w	%r10,0x14	; 	xld.w	%r10,0x00000014		; 20
	mlt.w	%r11,%r10
	ext	0x0		; 	xld.w	%r11,0x00000020		; 32
	ld.w	%r11,0x20
	ld.w	%r10,%alr
	add	%r10,%r11
	ld.w	%r13,%r6
	add	%r13,%r10
	ld.w	%r14,%r13
	ld.w	%r7,0x0
	ld.b	[%r13],%r7	; 	xld.b	[%r13],%r7
	ld.w	%r15,%r5
	add	%r15,%r4
	ld.ub	%r10,[%r15]	; 	xld.ub	%r10,[%r15]
	and	%r10,%r11
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jrne	__LX40		; 	xjrne	__L40
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	ext	0x3		; 	xld.ub	%r10,[%r15+3]
	ld.ub	%r10,[%r15]
	srl	%r10,0x3	; 	xsrl	%r10,3
	ext	apu_length_count_table+0x0@h	; 	xld.ub	%r10,[%r10+apu_length_count_table]
	ext	apu_length_count_table+0x0@m
	ld.w	%r9,apu_length_count_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	jp	__LX60		; 	xjp	__L60
__LX40:				; __L40:
	ext	0x3		; 	xld.w	%r10,0x000000ff		; 255
	ld.w	%r10,0x3f
__LX60:				; __L60:
	ext	0x1		; 	xld.b	[%r13+1],%r10
	ld.b	[%r13],%r10
	ld.w	%r10,%r5
	add	%r10,%r4
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	srl	%r10,0x6	; 	xsrl	%r10,6
	ext	apu_square_duty_table+0x0@h	; 	xld.ub	%r10,[%r10+apu_square_duty_table]
	ext	apu_square_duty_table+0x0@m
	ld.w	%r9,apu_square_duty_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ext	0xc		; 	xld.b	[%r14+12],%r10
	ld.b	[%r14],%r10
	ld.w	%r7,0x0
	ext	0xd		; 	xld.b	[%r14+13],%r7
	ld.b	[%r14],%r7
	ld.w	%r7,0x0
	ext	0x10		; 	xld.w	[%r14+16],%r7
	ld.w	[%r14],%r7
__L43:
	ld.w	%r11,%r12
	sra	%r11,0x2	; 	xsra	%r11,2
	ld.w	%r10,0x14	; 	xld.w	%r10,0x00000014		; 20
	mlt.w	%r11,%r10
	ld.w	%r10,%alr
	add	%r10,0x20	; 	xadd	%r10,%r10,32
	ld.w	%r14,%r6
	add	%r14,%r10
	ld.w	%r10,%r4
	add	%r10,%r5
	ext	0x2		; 	xld.ub	%r11,[%r10+2]
	ld.ub	%r11,[%r10]
	ext	0x3		; 	xld.ub	%r10,[%r10+3]
	ld.ub	%r10,[%r10]
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	ld.ub	%r10,%r10
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r11,%r10
	ext	0xa		; 	xld.h	[%r14+10],%r11
	ld.h	[%r14],%r11
	ext	__L28@rm	; 	xjp	__L28
	jp	__L28@rl
__L44:
	ld.w	%r13,%r15
	ld.w	%r7,0x0
	ld.b	[%r13],%r7	; 	xld.b	[%r13],%r7
	ld.w	%r11,%r5
	add	%r11,%r4
	btst	[%r11],0x7	; 	xbtst	[%r11],0x7
	jrne	__LX45		; 	xjrne	__L45
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	ext	0x3		; 	xld.ub	%r10,[%r11+3]
	ld.ub	%r10,[%r11]
	srl	%r10,0x3	; 	xsrl	%r10,3
	ext	apu_length_count_table+0x0@h	; 	xld.ub	%r10,[%r10+apu_length_count_table]
	ext	apu_length_count_table+0x0@m
	ld.w	%r9,apu_length_count_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	jp	__LX61		; 	xjp	__L61
__LX45:				; __L45:
	ext	0x3		; 	xld.w	%r10,0x000000ff		; 255
	ld.w	%r10,0x3f
__LX61:				; __L61:
	ext	0x1		; 	xld.b	[%r13+1],%r10
	ld.b	[%r13],%r10
	ext	0x2		; 	xadd	%r12,%r15,2
	add	%r12,%r15
	ld.w	%r7,0x0
	ld.b	[%r12],%r7	; 	xld.b	[%r12],%r7
	ld.w	%r11,%r5
	add	%r11,%r4
	btst	[%r11],0x7	; 	xbtst	[%r11],0x7
	jrne	__LX47		; 	xjrne	__L47
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	ext	0x1		; 	xand	%r10,%r10,0x0000007f
	and	%r10,0x3f
	jp	__LX62		; 	xjp	__L62
__LX47:				; __L47:
	ext	0x3		; 	xld.w	%r10,0x000000ff		; 255
	ld.w	%r10,0x3f
__LX62:				; __L62:
	ext	0x3		; 	xld.b	[%r15+3],%r10
	ld.b	[%r15],%r10
	ld.w	%r7,0x0
	ext	0x6		; 	xld.b	[%r15+6],%r7
	ld.b	[%r15],%r7
	ld.w	%r7,0x0
	ext	0x8		; 	xld.w	[%r15+8],%r7
	ld.w	[%r15],%r7
__L49:
	ld.w	%r10,%r4
	add	%r10,%r5
	ext	0x2		; 	xld.ub	%r11,[%r10+2]
	ld.ub	%r11,[%r10]
	ext	0x3		; 	xld.ub	%r10,[%r10+3]
	ld.ub	%r10,[%r10]
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	ld.ub	%r10,%r10
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r11,%r10
	ext	0x4		; 	xld.h	[%r15+4],%r11
	ld.h	[%r15],%r11
	jp	__L28		; 	xjp	__L28
__L50:
	ext	0x2		; 	xadd	%r12,%r14,2
	add	%r12,%r14
	ld.w	%r7,0x0
	ld.b	[%r12],%r7	; 	xld.b	[%r12],%r7
	ld.w	%r11,%r5
	add	%r11,%r4
	ld.ub	%r13,[%r11]	; 	xld.ub	%r13,[%r11]
	ld.w	%r10,%r13
	and	%r10,0x10	; 	xand	%r10,%r10,0x00000010
	jrne	__LX51		; 	xjrne	__L51
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
__LX64:				; __L64:
	cmp	%r10,0x0
	jreq	__LX52		; 	xjreq	__L52
	ld.w	%r10,0x3	; 	xld.w	%r10,0x00000003		; 3
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
__LX52:				; __L52:
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	add	%r10,0x1	; 	xadd	%r10,%r10,1
	ext	0x3		; 	xld.b	[%r14+3],%r10
	ld.b	[%r14],%r10
	ext	0x4		; 	xld.b	[%r14+4],%r10
	ld.b	[%r14],%r10
	ext	0x1		; 	xld.w	%r10,0x00000078		; 120
	ld.w	%r10,0x38
	ext	0x5		; 	xld.b	[%r14+5],%r10
	ld.b	[%r14],%r10
	jp	__L28		; 	xjp	__L28
__LX51:				; __L51:
	ld.w	%r10,%r13
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	sll	%r10,0x3	; 	xsll	%r10,3
	ext	0x5		; 	xld.b	[%r14+5],%r10
	ld.b	[%r14],%r10
	jp	__L28		; 	xjp	__L28
__L54:
	ld.w	%r7,0x0
	ld.b	[%r14],%r7	; 	xld.b	[%r14],%r7
	ld.w	%r11,%r5
	add	%r11,%r4
	btst	[%r11],0x5	; 	xbtst	[%r11],0x5
	jrne	__LX55		; 	xjrne	__L55
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.b	[%r14],%r10	; 	xld.b	[%r14],%r10
	ext	0x3		; 	xld.ub	%r10,[%r11+3]
	ld.ub	%r10,[%r11]
	srl	%r10,0x3	; 	xsrl	%r10,3
	ext	apu_length_count_table+0x0@h	; 	xld.ub	%r10,[%r10+apu_length_count_table]
	ext	apu_length_count_table+0x0@m
	ld.w	%r9,apu_length_count_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	jp	__LX63		; 	xjp	__L63
__LX55:				; __L55:
	ext	0x3		; 	xld.w	%r10,0x000000ff		; 255
	ld.w	%r10,0x3f
__LX63:				; __L63:
	ext	0x1		; 	xld.b	[%r14+1],%r10
	ld.b	[%r14],%r10
	ext	0x100		; 	xld.w	%r10,0x00004000		; 16384
	ld.w	%r10,0x0
	ext	0x8		; 	xld.h	[%r14+8],%r10
	ld.h	[%r14],%r10
	ld.w	%r7,0x0
	ext	0xc		; 	xld.w	[%r14+12],%r7
	ld.w	[%r14],%r7
	jp	__L28		; 	xjp	__L28
__L57:
	ld.w	%r11,%r4
	add	%r11,%r5
	add	%r11,0x2	; 	xadd	%r11,%r11,2
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	srl	%r10,0x7	; 	xsrl	%r10,7
	ext	0x6		; 	xld.b	[%r14+6],%r10
	ld.b	[%r14],%r10
	ld.ub	%r10,[%r11]	; 	xld.ub	%r10,[%r11]
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	sll	%r10,0x1	; 	xsll	%r10,1
	ext	apu_noise_wavelength_table+0x0@h	; 	xld.uh	%r10,[%r10+apu_noise_wavelength_table]
	ext	apu_noise_wavelength_table+0x0@m
	ld.w	%r9,apu_noise_wavelength_table+0x0@l
	add	%r9,%r10
	ld.uh	%r10,[%r9]
	ext	0xa		; 	xld.h	[%r14+10],%r10
	ld.h	[%r14],%r10
__L28:
	ret
	.align	1
	.global	apu_read
apu_read:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	apu+0x68@ah	; 	xld.ub	%r10,[apu+104]
	ext	apu+0x68@al
	ld.ub	%r10,[%r8]
	ld.w	%r11,%r10
	and	%r11,0x1f	; 	xand	%r11,%r11,0x0000001f
	ext	apu+0x15@ah	; 	xld.ub	%r12,[apu+21]
	ext	apu+0x15@al
	ld.ub	%r12,[%r8]
	and	%r12,%r11
	ld.w	%r11,%r12
	ext	0x2		; 	xand	%r10,%r10,0x000000bf
	and	%r10,0x3f
	ext	apu+0x68@ah	; 	xld.b	[apu+104],%r10
	ext	apu+0x68@al
	ld.b	[%r8],%r10
	ext	apu+0x21@ah	; 	xld.ub	%r10,[apu+33]
	ext	apu+0x21@al
	ld.ub	%r10,[%r8]
	cmp	%r10,0x0
	jrne	__LX66		; 	xjrne	__L66
	and	%r11,0x3e	; 	xand	%r11,%r11,0xfffffffe
__LX66:				; __L66:
	ext	apu+0x35@ah	; 	xld.ub	%r10,[apu+53]
	ext	apu+0x35@al
	ld.ub	%r10,[%r8]
	cmp	%r10,0x0
	jrne	__LX67		; 	xjrne	__L67
	and	%r11,0x3d	; 	xand	%r11,%r11,0xfffffffd
__LX67:				; __L67:
	ext	apu+0x49@ah	; 	xld.ub	%r10,[apu+73]
	ext	apu+0x49@al
	ld.ub	%r10,[%r8]
	cmp	%r10,0x0
	jrne	__LX68		; 	xjrne	__L68
	and	%r11,0x3b	; 	xand	%r11,%r11,0xfffffffb
__LX68:				; __L68:
	ext	apu+0x55@ah	; 	xld.ub	%r10,[apu+85]
	ext	apu+0x55@al
	ld.ub	%r10,[%r8]
	cmp	%r10,0x0
	jrne	__LX69		; 	xjrne	__L69
	and	%r11,0x37	; 	xand	%r11,%r11,0xfffffff7
__LX69:				; __L69:
	ld.w	%r10,%r11
	ret
	.align	1
	.global	apu_mix
apu_mix:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r1,%r12
	ext	apu+0x0@h	; 	xld.w	%r3,apu
	ext	apu+0x0@m
	ld.w	%r3,apu+0x0@l
	add	%r3,0x20	; 	xadd	%r3,%r3,32
	ld.w	%r13,0x0
	ext	0xa		; 	xld.w	%r14,0x00000280		; 640
	ld.w	%r14,0x0
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	ext	apu+0x69@ah	; 	xld.ub	%r2,[apu+105]
	ext	apu+0x69@al
	ld.ub	%r2,[%r8]
	ext	apu+0x6a@ah	; 	xld.ub	%r0,[apu+106]
	ext	apu+0x6a@al
	ld.ub	%r0,[%r8]
	ld.w	%r15,0x5	; 	xld.w	%r15,0x00000005		; 5
	ld.w	[%sp+0x0],%r15	; 	xld.w	[%sp],%r15
__LX71:				; __L71:
	add	%r2,0x18	; 	xadd	%r2,%r2,24
	cmp	%r2,0x18	; 	xcmp	%r2,24
	jrle	__LX74		; 	xjrle	__L74
	sub	%r2,0x19	; 	xsub	%r2,%r2,25
	cmp	%r0,0x3		; 	xcmp	%r0,3
	jrgt	__LX75		; 	xjrgt	__L75
	ext	0x2		; 	xadd	%r12,%r3,2
	add	%r12,%r3
	ext	apu_do_envelope@rm	; 	xcall	apu_do_envelope
	call	apu_do_envelope@rl
	ext	0x16		; 	xadd	%r12,%r3,22
	add	%r12,%r3
	ext	apu_do_envelope@rm	; 	xcall	apu_do_envelope
	call	apu_do_envelope@rl
	ext	apu+0x54@h	; 	xld.w	%r12,apu+84
	ext	apu+0x54@m
	ld.w	%r12,apu+0x54@l
	add	%r12,0x2	; 	xadd	%r12,%r12,2
	ext	apu_do_envelope@rm	; 	xcall	apu_do_envelope
	call	apu_do_envelope@rl
	ext	apu+0x48@h	; 	xld.w	%r12,apu+72
	ext	apu+0x48@m
	ld.w	%r12,apu+0x48@l
	add	%r12,0x2	; 	xadd	%r12,%r12,2
	ext	apu_do_linear@rm	; 	xcall	apu_do_linear
	call	apu_do_linear@rl
__LX75:				; __L75:
	ld.w	%r10,%r0
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX76		; 	xjreq	__L76
	ext	0x6		; 	xadd	%r12,%r3,6
	add	%r12,%r3
	ext	apu_do_sweep@rm	; 	xcall	apu_do_sweep
	call	apu_do_sweep@rl
	ext	0x1a		; 	xadd	%r12,%r3,26
	add	%r12,%r3
	ext	apu_do_sweep@rm	; 	xcall	apu_do_sweep
	call	apu_do_sweep@rl
__LX76:				; __L76:
	cmp	%r0,0x0
	jrne	__LX77		; 	xjrne	__L77
	ld.w	%r12,%r3
	call	apu_do_length	; 	xcall	apu_do_length
	ext	0x14		; 	xadd	%r12,%r3,20
	add	%r12,%r3
	call	apu_do_length	; 	xcall	apu_do_length
	ext	apu+0x48@h	; 	xld.w	%r12,apu+72
	ext	apu+0x48@m
	ld.w	%r12,apu+0x48@l
	call	apu_do_length	; 	xcall	apu_do_length
	ext	apu+0x54@h	; 	xld.w	%r12,apu+84
	ext	apu+0x54@m
	ld.w	%r12,apu+0x54@l
	call	apu_do_length	; 	xcall	apu_do_length
	ext	apu+0x17@ah	; 	xld.ub	%r11,[apu+23]
	ext	apu+0x17@al
	ld.ub	%r11,[%r8]
	ld.w	%r10,%r11
	ext	0x2		; 	xand	%r10,%r10,0x00000080
	and	%r10,0x0
	jrne	__LX78		; 	xjrne	__L78
	ld.w	%r0,0x4		; 	xld.w	%r0,0x00000004		; 4
	ld.w	%r10,%r11
	ext	0x1		; 	xand	%r10,%r10,0x00000040
	and	%r10,0x0
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jrne	__LX77		; 	xjrne	__L77
	ext	0x1		; 	xld.w	%r10,0x00000040		; 64
	ld.w	%r10,0x0
	ext	apu+0x68@ah	; 	xld.ub	%r15,[apu+104]
	ext	apu+0x68@al
	ld.ub	%r15,[%r8]
	or	%r10,%r15
	ext	apu+0x68@ah	; 	xld.b	[apu+104],%r10
	ext	apu+0x68@al
	ld.b	[%r8],%r10
	jp	__LX77		; 	xjp	__L77
__LX78:				; __L78:
	ld.w	%r0,0x5		; 	xld.w	%r0,0x00000005		; 5
__LX77:				; __L77:
	sub	%r0,0x1		; 	xsub	%r0,%r0,1
__LX74:				; __L74:
	ext	apu+0x15@ah	; 	xbtst	[apu+21],0x0
	ext	apu+0x15@al
	btst	[%r8],0x0
	jreq	__LX81		; 	xjreq	__L81
	ld.w	%r12,%r3
	ld.w	%r13,%r1
	ext	apu_square_mix@rm	; 	xcall	apu_square_mix
	call	apu_square_mix@rl
__LX81:				; __L81:
	ext	apu+0x15@ah	; 	xbtst	[apu+21],0x1
	ext	apu+0x15@al
	btst	[%r8],0x1
	jreq	__LX82		; 	xjreq	__L82
	ext	0x14		; 	xadd	%r12,%r3,20
	add	%r12,%r3
	ld.w	%r13,%r1
	ext	apu_square_mix@rm	; 	xcall	apu_square_mix
	call	apu_square_mix@rl
__LX82:				; __L82:
	ext	apu+0x15@ah	; 	xbtst	[apu+21],0x2
	ext	apu+0x15@al
	btst	[%r8],0x2
	jreq	__LX83		; 	xjreq	__L83
	ext	apu+0x48@h	; 	xld.w	%r12,apu+72
	ext	apu+0x48@m
	ld.w	%r12,apu+0x48@l
	ld.w	%r13,%r1
	ext	apu_triangle_mix@rm	; 	xcall	apu_triangle_mix
	call	apu_triangle_mix@rl
__LX83:				; __L83:
	ext	apu+0x15@ah	; 	xbtst	[apu+21],0x3
	ext	apu+0x15@al
	btst	[%r8],0x3
	jreq	__LX84		; 	xjreq	__L84
	ext	apu+0x54@h	; 	xld.w	%r12,apu+84
	ext	apu+0x54@m
	ld.w	%r12,apu+0x54@l
	ld.w	%r13,%r1
	ext	apu_noise_mix@rm	; 	xcall	apu_noise_mix
	call	apu_noise_mix@rl
__LX84:				; __L84:
	ext	apu+0x15@ah	; 	xbtst	[apu+21],0x4
	ext	apu+0x15@al
	btst	[%r8],0x4
	jreq	__LX85		; 	xjreq	__L85
	ext	apu+0x64@h	; 	xld.w	%r12,apu+100
	ext	apu+0x64@m
	ld.w	%r12,apu+0x64@l
	ld.w	%r13,%r1
	ext	apu_dmc_mix@rm	; 	xcall	apu_dmc_mix
	call	apu_dmc_mix@rl
__LX85:				; __L85:
	ext	0x2		; 	xadd	%r1,%r1,128
	add	%r1,0x0
	ld.w	%r15,[%sp+0x0]	; 	xld.w	%r15,[%sp]
	sub	%r15,0x1	; 	xsub	%r15,%r15,1
	ld.w	[%sp+0x0],%r15	; 	xld.w	[%sp],%r15
	ext	__LX71@rm	; 	xjrne	__L71
	jrne	__LX71@rl
	ext	apu+0x69@ah	; 	xld.b	[apu+105],%r2
	ext	apu+0x69@al
	ld.b	[%r8],%r2
	ext	apu+0x6a@ah	; 	xld.b	[apu+106],%r0
	ext	apu+0x6a@al
	ld.b	[%r8],%r0
	ext	0x280		; 	xsub	%r12,%r1,640
	sub	%r12,%r1
	ext	apu_volume_shift@rm	; 	xcall	apu_volume_shift
	call	apu_volume_shift@rl
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	apu_do_length
apu_do_length:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	btst	[%r12],0x0	; 	xbtst	[%r12],0x0
	jreq	__LX88		; 	xjreq	__L88
	ext	0x1		; 	xld.ub	%r11,[%r12+1]
	ld.ub	%r11,[%r12]
	ld.ub	%r10,%r11
	cmp	%r10,0x0
	jreq	__LX88		; 	xjreq	__L88
	ext	0x1		; 	xsub	%r10,%r11,1
	sub	%r10,%r11
	ext	0x1		; 	xld.b	[%r12+1],%r10
	ld.b	[%r12],%r10
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jrne	__LX88		; 	xjrne	__L88
	bclr	[%r12],0x0	; 	xbclr	[%r12],0x0
__LX88:				; __L88:
	ret
	.align	1
	.global	apu_do_linear
apu_do_linear:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	btst	[%r12],0x0	; 	xbtst	[%r12],0x0
	jreq	__LX92		; 	xjreq	__L92
	ext	0x1		; 	xld.ub	%r10,[%r12+1]
	ld.ub	%r10,[%r12]
	sub	%r10,0x1	; 	xsub	%r10,%r10,1
	ext	0x1		; 	xld.b	[%r12+1],%r10
	ld.b	[%r12],%r10
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jrne	__LX92		; 	xjrne	__L92
	bclr	[%r12],0x0	; 	xbclr	[%r12],0x0
__LX92:				; __L92:
	ret
	.align	1
	.global	apu_do_envelope
apu_do_envelope:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	btst	[%r12],0x0	; 	xbtst	[%r12],0x0
	jreq	__LX95		; 	xjreq	__L95
	ext	0x2		; 	xld.ub	%r10,[%r12+2]
	ld.ub	%r10,[%r12]
	sub	%r10,0x1	; 	xsub	%r10,%r10,1
	ext	0x2		; 	xld.b	[%r12+2],%r10
	ld.b	[%r12],%r10
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jrne	__LX95		; 	xjrne	__L95
	ext	0x1		; 	xld.ub	%r10,[%r12+1]
	ld.ub	%r10,[%r12]
	ext	0x2		; 	xld.b	[%r12+2],%r10
	ld.b	[%r12],%r10
	ext	0x3		; 	xld.ub	%r10,[%r12+3]
	ld.ub	%r10,[%r12]
	sub	%r10,0x8	; 	xsub	%r10,%r10,8
	ext	0x3		; 	xld.b	[%r12+3],%r10
	ld.b	[%r12],%r10
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jrne	__LX95		; 	xjrne	__L95
	ld.ub	%r11,[%r12]	; 	xld.ub	%r11,[%r12]
	ld.w	%r10,%r11
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	jreq	__LX98		; 	xjreq	__L98
	ext	0x1		; 	xld.w	%r10,0x00000078		; 120
	ld.w	%r10,0x38
	ext	0x3		; 	xld.b	[%r12+3],%r10
	ld.b	[%r12],%r10
	jp	__LX95		; 	xjp	__L95
__LX98:				; __L98:
	ld.w	%r10,%r11
	ext	0x3		; 	xand	%r10,%r10,0x000000fe
	and	%r10,0x3e
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
__LX95:				; __L95:
	ret
	.align	1
	.global	apu_do_sweep
apu_do_sweep:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r13,%r12
	btst	[%r13],0x0	; 	xbtst	[%r13],0x0
	jreq	__LX101		; 	xjreq	__L101
	ext	0x3		; 	xld.ub	%r10,[%r13+3]
	ld.ub	%r10,[%r13]
	sub	%r10,0x1	; 	xsub	%r10,%r10,1
	ext	0x3		; 	xld.b	[%r13+3],%r10
	ld.b	[%r13],%r10
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jrne	__LX101		; 	xjrne	__L101
	ext	0x2		; 	xld.ub	%r10,[%r13+2]
	ld.ub	%r10,[%r13]
	ext	0x3		; 	xld.b	[%r13+3],%r10
	ld.b	[%r13],%r10
	btst	[%r13],0x1	; 	xbtst	[%r13],0x1
	jrne	__LX103		; 	xjrne	__L103
	ext	0x4		; 	xld.uh	%r10,[%r13+4]
	ld.uh	%r10,[%r13]
	ld.h	%r11,%r10
	ext	0x1		; 	xld.ub	%r12,[%r13+1]
	ld.ub	%r12,[%r13]
	ld.w	%r9,%r12	; 	xsra	%r11,%r12
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sra	%r11,0x8
	jp.d	-3
	sub	%r9,0x8
	sra	%r11,%r9
	add	%r10,%r11
	ext	0x4		; 	xld.h	[%r13+4],%r10
	ld.h	[%r13],%r10
	ld.h	%r10,%r10
	ext	0x1f		; 	xcmp	%r10,2046
	cmp	%r10,0x3e
	jrle	__LX101		; 	xjrle	__L101
	ext	0x1f		; 	xld.w	%r10,0x000007ff		; 2047
	ld.w	%r10,0x3f
	jp	__LX107		; 	xjp	__L107
__LX103:				; __L103:
	ext	0x4		; 	xld.uh	%r10,[%r13+4]
	ld.uh	%r10,[%r13]
	ld.h	%r11,%r10
	ext	0x1		; 	xld.ub	%r12,[%r13+1]
	ld.ub	%r12,[%r13]
	ld.w	%r9,%r12	; 	xsra	%r11,%r12
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sra	%r11,0x8
	jp.d	-3
	sub	%r9,0x8
	sra	%r11,%r9
	sub	%r10,%r11
	ext	0x4		; 	xld.h	[%r13+4],%r10
	ld.h	[%r13],%r10
	ld.h	%r10,%r10
	cmp	%r10,0x8	; 	xcmp	%r10,8
	jrgt	__LX101		; 	xjrgt	__L101
	ld.w	%r10,0x8	; 	xld.w	%r10,0x00000008		; 8
__LX107:				; __L107:
	ext	0x4		; 	xld.h	[%r13+4],%r10
	ld.h	[%r13],%r10
	bclr	[%r13],0x0	; 	xbclr	[%r13],0x0
__LX101:				; __L101:
	ret

	.comm	apu 108
